package com.nd.smartcan.content.s3.model;

import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.Map;
import java.util.UUID;

/**
 * 索引节点
 * Created by zmc on 2015/4/1.
 */
public class S3INode {

    /**
     * 索引节点码Id(UUID)
     */
    @JsonProperty("inode_id")
    private UUID mINodeId;

    /**
     * 文件MD5
     */
    @JsonProperty("md5")
    private String mMd5;

    /**
     * 大小 (byte)
     */
    @JsonProperty("size")
    private long mSize;

    /**
     * MIME
     */
    @JsonProperty("mime")
    private String mMIME;

    /**
     * 扩展名(小写)
     */
    @JsonProperty("ext")
    private String mExt;

    /**
     * 图片，音频，视频等元数据： {width: 1024, height: 768}
     */
    @JsonProperty("meta")
    private Map<String, Object> mMeta;

    /**
     * 引用数
     */
    @JsonProperty("links")
    private int mLinks;

    /**
     * ip地址
     */
    @JsonProperty("ip")
    private String mIP;

    /**
     * 创建时间，ISO8601规范,例如"2015-02-15T07:56:29.356+0000"
     */
    @JsonProperty("create_at")
    private Long mCreateAt;

    public S3INode() {
    }

    public S3INode(UUID iNodeId, String md5, long size, String MIME, String ext, Map<String, Object> meta,
                   int links, String ip, Long createAt) {
        mINodeId = iNodeId;
        mMd5 = md5;
        mSize = size;
        mMIME = MIME;
        mExt = ext;
        mMeta = meta;
        mLinks = links;
        mIP = ip;
        mCreateAt = createAt;
    }

    @JsonProperty("inode_id")
    public final UUID getINodeId() {
        return mINodeId;
    }

    @JsonProperty("inode_id")
    public final void setINodeId(UUID iNodeId) {
        mINodeId = iNodeId;
    }

    @JsonProperty("md5")
    public final String getMd5() {
        return mMd5;
    }

    @JsonProperty("md5")
    public final void setMd5(String md5) {
        mMd5 = md5;
    }

    @JsonProperty("size")
    public final long getSize() {
        return mSize;
    }

    @JsonProperty("size")
    public final void setSize(long size) {
        mSize = size;
    }

    @JsonProperty("mime")
    public final String getMIME() {
        return mMIME;
    }

    @JsonProperty("mime")
    public final void setMIME(String MIME) {
        mMIME = MIME;
    }

    @JsonProperty("ext")
    public final String getExt() {
        return mExt;
    }

    @JsonProperty("ext")
    public final void setExt(String ext) {
        mExt = ext;
    }

    @JsonProperty("meta")
    public final Map<String, Object> getMeta() {
        return mMeta;
    }

    @JsonProperty("meta")
    public final void setMeta(Map<String, Object> meta) {
        mMeta = meta;
    }

    @JsonProperty("links")
    public final int getLinks() {
        return mLinks;
    }

    @JsonProperty("links")
    public final void setLinks(int links) {
        mLinks = links;
    }

    @JsonProperty("ip")
    public final String getIP() {
        return mIP;
    }

    @JsonProperty("ip")
    public final void setIP(String IP) {
        mIP = IP;
    }

    @JsonProperty("create_at")
    public final Long getCreateAt() {
        return mCreateAt;
    }

    @JsonProperty("create_at")
    public final void setCreateAt(Long createAt) {
        mCreateAt = createAt;
    }
}
