package com.nd.smartcan.content.s3.model;

import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.Map;
import java.util.UUID;

/**
 * Created by Administrator on 2016/3/28.
 */
public class S3UpLoadToken {
    private static final String KEY_DENTRY_ID = "dentry_id";
    private static final String KEY_SERVICE_ID = "service_id";
    private static final String KEY_PARENT_ID = "parent_id";
    private static final String KEY_PATH = "path";
    private static final String KEY_TYPE = "type";
    private static final String KEY_NAME = "name";
    private static final String KEY_OTHER_NAME = "other_name";
    private static final String KEY_INFO = "info";
    private static final String KEY_SCOPE = "scope";
    private static final String KEY_UID = "uid";
    private static final String KEY_HITS = "hits";
    private static final String KEY_CREATE_AT = "create_at";
    private static final String KEY_UPDATE_AT = "update_at";
    private static final String KEY_EXPIRE_AT = "expire_at";
    private static final String KEY_FLAG = "flag";
    private static final String KEY_INODE = "inode";
    private static final String KEY_INODE_ID = "inode_id";
    private static final String KEY_UPLOAD_PARAMS = "upload_params";
    /**
     * 目录项id（UUID）
     */
    @JsonProperty(KEY_DENTRY_ID)
    public UUID mDentryId;

    /**
     * 服务id（UUID）
     */
    @JsonProperty(KEY_SERVICE_ID)
    public UUID mServiceId;

    /**
     * 父目录项id（UUID）
     */
    @JsonProperty(KEY_PARENT_ID)
    public UUID mParentId;

    /**
     * 目录项路径（文件包括扩展名）
     */
    @JsonProperty(KEY_PATH)
    public String mPath;

    /**
     * 类型：0=目录 1=文件 2=连接文件
     */
    @JsonProperty(KEY_TYPE)
    public int mType;

    /**
     * 目录项名（文件一般包括扩展名）
     */
    @JsonProperty(KEY_NAME)
    public String mName;

    /**
     * 备注名
     */
    @JsonProperty(KEY_OTHER_NAME)
    public String mOtherName;

    /**
     * 自定义元数据，如：{tags: [xx,xx], title: xx, note: xx, content: xx}
     */
    @JsonProperty(KEY_INFO)
    public Map mInfo;

    /**
     * 公开范围：0=私密 1=完全公开 2=需要访问密码。默认为0
     */
    @JsonProperty(KEY_SCOPE)
    public int mScope;

    /**
     * 拥有者uid/上传者uid
     */
    @JsonProperty(KEY_UID)
    public Long mUid;

    /**
     * 访问次数
     */
    @JsonProperty(KEY_HITS)
    public int mHits;

    /**
     * 创建时间，1970年1月1日0时0分0秒起, 流逝的毫秒数
     */
    @JsonProperty(KEY_CREATE_AT)
    public Long mCreateAt;

    /**
     * 最后更新时间，1970年1月1日0时0分0秒起, 流逝的毫秒数
     */
    @JsonProperty(KEY_UPDATE_AT)
    public Long mUpdateAt;

    /**
     * 过期时间，1970年1月1日0时0分0秒起, 流逝的毫秒数
     */
    @JsonProperty(KEY_EXPIRE_AT)
    public Long mExpireAt;

    /**
     * 标识：-3=合并中 -2=转码中 -1=逻辑删除 0=隐藏 1=正常显示
     */
    @JsonProperty(KEY_FLAG)
    public int mFlag;

    /**
     * 文件索引节点，当该目录项为目录时（type = 0）该字段为空
     */
    @JsonProperty(KEY_INODE)
    public S3INode mINode;

    /**
     * 索引节点id（UUID）当该目录项为目录时（type = 0）该字段为空
     */
    @JsonProperty(KEY_INODE_ID)
    public UUID mINodeId;

    /**
     * 文件索引节点，当该目录项为目录时（type = 0）该字段为空
     */
    @JsonProperty(KEY_UPLOAD_PARAMS)
    public S3UpLoadParams mUpLoadParams;
}
