package com.nd.smartcan.content.s3.utils;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.io.IOException;
import java.io.StringReader;
import java.util.ArrayList;

/**
 * xml操作类
 */
public class XmlParse {
    /**
     * 把给定的etag列表封装成完成分块上传所需要的xml
     * @param etags
     * @return
     */
    public static String getCompleteMultipartXmlStream(ArrayList<String> etags){
        StringBuffer xml = new StringBuffer();
        xml.append("<CompleteMultipartUpload>");

        for (int i = 0; i < etags.size(); i++) {
            xml.append("<Part>");

            xml.append("<PartNumber>");
            xml.append(i+1);
            xml.append("</PartNumber>");

            xml.append("<ETag>");
            xml.append(etags.get(i));
            xml.append("</ETag>");

            xml.append("</Part>");
        }
        xml.append("</CompleteMultipartUpload>");

        return xml.toString();
    }

    /**
     * 从给定的xml字符串获取到UploadId标签的值
     *
     * @param xmlString xml字符串
     * @return String
     * @throws Exception
     */
    public static String getUploadId(String xmlString) throws ParserConfigurationException, IOException, SAXException {
        DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
        DocumentBuilder dbBuilder = dbFactory.newDocumentBuilder();
        InputSource isInputSource = new InputSource(new StringReader(xmlString));
        Document doc = dbBuilder.parse(isInputSource);
        NodeList nList = doc.getElementsByTagName("UploadId");
        return nList.item(0).getFirstChild().getNodeValue();
    }
}